



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【JVM.5】类文件结构</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【JVM.5】类文件结构</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 18:41:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>鲁迅曾经说过：代码编译的结构从本地机器码转变为字节码，是存储格式发展的一小步，确是编程语言发展的一大步。</p>
<p>一.无关性的基石</p>
<p>　　Java设计者在最初就承诺过&ldquo;In the future, we will consider bounded extensions to the Java virtual machine to privide better support for other languages&rdquo;(在未来，我们会对Java虚拟机进行适当的扩展，以便更好地支持其他语言运行于JVM之上）。</p>
<p>　　时至今日，在Java语言之外已经有大批在Java虚拟机之上运行的语言，如Clojure、Groovy、JRuby、Jython、Scala等。</p>
<p>　　Java虚拟机不和包括Java在内的任何语言绑定，它只与&ldquo;Class文件&rdquo;这种特定的二进制文件格式所关联。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523112516273-1844288491.png" />&nbsp; &nbsp; &nbsp;图：java虚拟机提供的语言无关性</p>
<p>三.Class类文件的结构</p>
<p>　　Class文件是一组以8位字节为基础单位的二进制流，各个数据项目严格按照顺序紧凑地排列在Class文件之中，中间没有添加任何分隔符。</p>
<p>　　Java文件格式采用一种类似于C语言结构体的伪结构来存储数据，这种伪结构只有两种数据：无符号数和表。</p>
<p>　　无符号数属于基本的数据类型(八种)，以u1，u2，u4，u8来分别表示1个字节、2个字节、4个字节、8个字节的无符号数。</p>
<p>　　表是由多个无符号数或者其他表作为数据项构成的符合数据类型。整个Class文件本质上就是一张表</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523113854461-1891460430.png" />&nbsp; &nbsp; 图：Class文件格式</p>
<p>　　无论是无符号数还是表，当需要描述同一类型但数量不一定的多个数据时，经常会使用一个前置的容量计数器加若干个连续的数据项的形式，这是称这一系列连续的某一类型的数据为某一类型的集合。</p>
<p>1.　　魔数(Magic Number)与Class文件的版本</p>
<p>　　每个Class文件的头4个字节(u4)称为魔数()，它的唯一作用是确定这个文件是否为一个能被虚拟机接受的Class文件。</p>
<p>　　在魔数之后的4个字节存储的Class文件的版本号：第5和第6个字节是次版本号（Minor Version），第7和第8个字节是主版本号（Major Version）。</p>
<p>　　Java的版本是从45开始的。高版本可以向下兼容。</p>
<p>　　可以用十六进制编辑器WinHex打开class文件看看：</p>
<div>
<pre class="prettyprint linenums">package com.yuanbaopu.fide.chief.service;

import com.yuanbaopu.fide.common.FileDto;

public interface AccountService {

    FileDto getAccountFile(String uuid);

}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523134247962-631356633.png" /></p>
<p>这里的主版本是51，从45（JDK1.1）开始的话，51就对应着JDK1.7。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523134542638-1209951693.png" />&nbsp; &nbsp; 图：Class文件版本号</p>
<p>2.　　常量池</p>
<p>　　紧接着版本号之后的是常量池入口，常量池可以理解为Class文件之中的资源仓库，是占用Class文件空间最大的数据项目之一，也是Class文件中第一个出现的表类型数据项目。</p>
<p>　　由于常量池数量不是固定的，所以在常量池的入口需要放置一项u2类型的数据（可以对照Class文件格式图方便了解），代表常量池计数器（constant_pool_count）。与Java习惯不一样的是，这个容器的计数是从1开始而不是0，设计者把0空出来有特殊的考虑：&ldquo;不引用任何一个常量池项目&rdquo;。 如下图，我们可以知道常量池共有9项常量，除去默认的一个，则还有8项常量。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523135650847-958470352.png" /></p>
<p>　　常量池中每一项常量都是一个表，每个表都有一个共同特点，就是表开始的第一位是一个u1类型的标志位，代表当前的这个常量属于哪种常量类型。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523140932057-1136912100.png" /></p>
<p>　　不难发现，第一个标志为&ldquo;7&rdquo;对应着&ldquo;CONSTANT_Class_info&rdquo;,而&ldquo;CONSTANT_Class_info&rdquo;类型的常量结构如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523141703010-507303968.png" /></p>
<p>　　tag是标志位，上面已经讲过了，它用于区分常量类型；name_index是一个索引值，它指向常量池中一个&ldquo;CONSTANT_Utf8_info&rdquo;类型的常量，此常量代表了这个类或接口的全限定名。</p>
<p>　　我们再看一下&ldquo;CONSTANT_Utf8_info&rdquo;型常量的结构</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523142434448-815381309.png" /></p>
<p>并贴上常量池的14种常量项的结构总表：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523145439686-1280692411.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523145505563-940579169.png" /></p>
<p>　　后面的其他几个常量，为了避免占用过多版面，我们使用JDK的bin目录下的一个工具：javap。</p>
<p>　　使用javap工具的 -verbose参数输出AccountService.class文件字节码内容。</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523144733407-1782236953.png" /></p>
<p>我们看一个详细的对照例子（图片太小可以右键&ldquo;在新标签页中打开图片&rdquo;）：看一下、看一下、看一下......</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180524135246130-1585557522.png" /></p>
<p>3.　　访问标志（access_flags）</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523152239443-1456171737.png" /></p>
<p>4.　　类索引(this_class)、父类索引(super_class)与接口索引(interfaces)集合</p>
<p>　　类索引和父类索引都是一个u2类型的数据，而接口索引集合是一组u2类型的数据的集合，Class文件中由这三项数据来确定这个类的继承关系。</p>
<p>5.　　字段表(field_info)集合</p>
<p>　　字段访问标志：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523154344838-992656910.png" /></p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523155227076-1956904996.png" /></p>
<p>　　对于数组类型，每一个维度将使用一个前置的&ldquo;[&rdquo;字符来描述，如定义一个&ldquo;java.lang.String[][]&rdquo;将被记录为&ldquo;[[java.lang.String&rdquo;</p>
<p>6.　　方法表集合</p>
<p>　　方法访问标志：<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523160907592-945365243.png" /></p>
<p>7.　　属性表(attribute_info)集合</p>
<p>　　虚拟机规范预定义属性：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523162603220-1413581126.png" /></p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1336620/201805/1336620-20180523162639677-1597918648.png" /></p>
<p>　　注意：有个小知识：在任何实例方法里面，都可以通过&ldquo;this&rdquo;关键字访问到此方法所属的对象。这个访问机制对Java程序编写很重要，而它的实现却很简单，</p>
<p>　　仅仅是通过Javac编译器编译的时候把对this关键字的访问转变为对一个普通方法参数的访问，然后在虚拟机调用实例方法时自动传入此参数而已。因此在实例方法的局部变量表中至少会存在一个指向当前对象实例的局部变量。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z16nn9.html">&lbrack;LeetCode&rsqb; Gas Station 加油站问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd52479.html">洛谷 P1373 小a和uim之大逃离 Label：dp 不会</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8krj56q.html">微信5&period;0之Fragment使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1wggz9.html">福利-&amp;gt&semi;KVC&plus;Runtime获取类&sol;对象的属性&sol;成员变量&sol;方法&sol;协议并实现字典转模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g762e9.html">使用servers 启动项目时 ，一直处于启动中， 最后出现无法的问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm5vde9.html">OpenCV源码阅读&lpar;3&rpar;---matx&period;h---学习心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdnger8.html">SYN&comma; FIN&comma; ACK&comma; PSH&comma; RST&comma; URG</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mvjvxq.html">servlet&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1e1r28.html">CONCATENATION 引发的性能问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oez739.html">使用VisualVM查看Java Heap Dump</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wrmlxq.html">Struts2 访问web元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvgoejq.html">java list 的 四种遍历方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp03y39.html">LWP&colon;&colon;UserAgent - Web user agent class   Web 用户agent 类&colon;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mj4x38.html">复习php的一些函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd7ko79.html">CSS中的路径裁剪样式clip-path</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1j0xxq.html">this的用法 &ndash; JavaScript深入浅出（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzxv7l8.html">IEEE1588 verision2 报文介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zwm259.html">【C&num;】数据库脚本生成工具（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k35w29.html">kali权限提升之配置不当提权与WCE</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1k6wgq.html">CodeBlocks卸载后重装 编译c文件提示错误信息&OpenCurlyDoubleQuote;No such file or directory&rdquo;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gjx6xz9.html">jmeter利用自身代理录制脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvzp638.html">python第四十八天--高级FTP</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjxyz49.html">Ubuntu下matplotlib的中文显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gn1zvq.html">What To Do When MySQL Runs Out of Memory&colon; Troubleshooting Guide</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvzm7y8.html">Web服务并发I&sol;O模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o12641q.html">Linux远程访问及控制（SSH）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j6o7eq.html">ELK-logstash-6&period;3&period;2部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zylz2x9.html">路由交换04-----STP</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gno0mq.html">Java读取properties文件工具类并解决控制台中文乱码</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j6ly3q.html">div放在li标签中，无法撑开li标签的问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
